; 
InsertColumn proc
    LOCAL lvc :LV_COLUMN
             mov lvc.lx, 75                            ; column width
             mov lvc.imask, LVCF_TEXT + LVCF_WIDTH     ; LVCF_TEXT requires pszText, LVCF_WIDTH requires lx
             mov lvc.iSubItem, 0                                  ; zero-based index
             mov lvc.pszText, offset Heading0                     ; required because we used LVCF_TEXT above
             mov lvc.cchTextMax, SizeOf Heading0                  ; pszText buffer size
	invoke SendMessage, hList, LVM_INSERTCOLUMN, 1, addr lvc    ; adds column to viewlist
             mov lvc.lx, 55                                       ; all cols will now have this width
             mov lvc.imask, LVCF_TEXT + LVCF_WIDTH + LVCF_FMT     ; add formating capabillities to cols
             mov lvc.fmt, LVCFMT_RIGHT                            ; the rest of the cols are assigned right justify
             mov lvc.iSubItem, 1
             mov lvc.pszText, offset Heading1
             mov lvc.cchTextMax,  SizeOf Heading1
	invoke SendMessage, hList, LVM_INSERTCOLUMN, 2, addr lvc
             mov lvc.iSubItem, 2
             mov lvc.pszText, offset Heading2
             mov lvc.cchTextMax,  SizeOf Heading2
	invoke SendMessage, hList, LVM_INSERTCOLUMN, 3, addr lvc
             mov lvc.iSubItem, 3
             mov lvc.pszText, offset Heading3
             mov lvc.cchTextMax,  SizeOf Heading3
	invoke SendMessage, hList, LVM_INSERTCOLUMN, 4, addr lvc
             mov lvc.iSubItem, 4
             mov lvc.pszText, offset Heading4
             mov lvc.cchTextMax,  SizeOf Heading4
	invoke SendMessage, hList, LVM_INSERTCOLUMN, 5, addr lvc
             mov lvc.iSubItem, 5
             mov lvc.pszText, offset Heading5
             mov lvc.cchTextMax, SizeOf Heading5
	invoke SendMessage, hList, LVM_INSERTCOLUMN, 6, addr lvc
    ret
InsertColumn endp
; 
FillData proc
    LOCAL lvi :LV_ITEM
    LOCAL row :DWORD
    LOCAL pNumCols :WORD
    invoke SQLBindCol, hStmt, 1, SQL_C_CHAR, addr ODBCField01, sizeof ODBCField01, addr ODBCField01L
    invoke SQLBindCol, hStmt, 2, SQL_C_CHAR, addr ODBCField02, sizeof ODBCField02, addr ODBCField02L
    invoke SQLBindCol, hStmt, 3, SQL_C_CHAR, addr ODBCField03, sizeof ODBCField03, addr ODBCField03L
    invoke SQLBindCol, hStmt, 4, SQL_C_CHAR, addr ODBCField04, sizeof ODBCField04, addr ODBCField04L
    invoke SQLBindCol, hStmt, 5, SQL_C_CHAR, addr ODBCField05, sizeof ODBCField05, addr ODBCField05L
    invoke SQLBindCol, hStmt, 6, SQL_C_CHAR, addr ODBCField06, sizeof ODBCField06, addr ODBCField06L
    invoke SendMessage, hList, WM_SETREDRAW, 0, 0   ; stop the updating of the screen area while loading hList
    mov row, 0
    .while TRUE
           mov byte ptr ds:[ODBCField01], 0 ; We initalize the buffers to zero, incase there is no data selected
           mov byte ptr ds:[ODBCField02], 0 ;    and we still want to process to finish without erroring out
           mov byte ptr ds:[ODBCField03], 0
           mov byte ptr ds:[ODBCField04], 0
           mov byte ptr ds:[ODBCField05], 0
           mov byte ptr ds:[ODBCField06], 0
           invoke SQLFetch, hStmt
           .if ax == SQL_SUCCESS
                mov lvi.imask, LVIF_TEXT + LVIF_PARAM
                push row
                pop lvi.iItem
                mov lvi.iSubItem, 0
                mov lvi.pszText, offset ODBCField01
                push row
                pop lvi.lParam
                invoke SendMessage, hList, LVM_INSERTITEM, 0, addr lvi
                    mov lvi.imask, LVIF_TEXT
                    inc lvi.iSubItem
                    mov lvi.pszText, offset ODBCField02
                invoke SendMessage, hList, LVM_SETITEM, 0, addr lvi
                    inc lvi.iSubItem
                    mov lvi.pszText, offset ODBCField03
                invoke SendMessage, hList, LVM_SETITEM, 0, addr lvi
                    inc lvi.iSubItem
                    mov lvi.pszText, offset ODBCField04
                invoke SendMessage, hList, LVM_SETITEM, 0, addr lvi
                    inc lvi.iSubItem
                    mov lvi.pszText, offset ODBCField05
                invoke SendMessage, hList, LVM_SETITEM, 0, addr lvi
                    inc lvi.iSubItem
                    mov lvi.pszText, offset ODBCField06
                invoke SendMessage, hList, LVM_SETITEM, 0, addr lvi
                inc lvi.iSubItem
                inc row
            .else
                .if row == 0
                    mov lvi.imask, LVIF_TEXT + LVIF_PARAM
                    push row
                    pop lvi.iItem
                    mov lvi.iSubItem, 0
                    mov lvi.pszText, offset Zrecords
                    push row
                    pop lvi.lParam
                    invoke SendMessage, hList2, LVM_INSERTITEM, 0, addr lvi
                .endif
                .break   ; when no more records left, we exit the infinite loop
            .endif
    .endw
    invoke SendMessage, hList, WM_SETREDRAW, 1, 0       ; start the updating of the screen area for hList
    invoke ShowWindow, hList, SW_SHOW
    ret
FillData endp
; 
RunQuery proc hDlg :DWORD
    invoke ShowWindow, hList, SW_HIDE
    invoke ShowWindow, hList2, SW_HIDE
    invoke ShowWindow, hList3, SW_HIDE
    invoke SendMessage, hList, LVM_DELETEALLITEMS, 0, 0
    invoke SQLAllocHandle, SQL_HANDLE_STMT, hConn, addr hStmt
    .if ax==SQL_SUCCESS || ax==SQL_SUCCESS_WITH_INFO
        invoke SQLExecDirect, hStmt, addr SQLStatement, sizeof SQLStatement
        .if ax==SQL_SUCCESS || ax==SQL_SUCCESS_WITH_INFO
            invoke FillData
        .elseif ax == SQL_ERROR
            invoke ShowWindow, hList, SW_HIDE
            invoke MessageBox, hDlg, addr sqlerr1, addr AppName, MB_OK     ; SQL Error
        .elseif ax == SQL_INVALID_HANDLE
            invoke ShowWindow, hList, SW_HIDE
            invoke MessageBox, hDlg, addr sqlerr2, addr AppName, MB_OK     ; Invalid Handle
        .elseif ax == SQL_NEED_DATA
            invoke ShowWindow, hList, SW_HIDE
            invoke MessageBox, hDlg, addr sqlerr3, addr AppName, MB_OK     ; SQL incomplete
        .elseif ax == SQL_NO_DATA
            invoke ShowWindow, hList, SW_HIDE
            invoke MessageBox, hDlg, addr sqlerr4, addr AppName, MB_OK     ; SQL returned no data
        .elseif ax == SQL_STILL_EXECUTING
            invoke MessageBox, hDlg, addr sqlerr5, addr AppName, MB_OK     ; Still executing SQL stmt
        .else
            invoke ShowWindow, hList, SW_HIDE
            invoke MessageBox, hDlg, addr ExecuteFail, addr AppName, MB_OK + MB_ICONERROR
        .endif
        invoke SQLCloseCursor, hStmt
        invoke SQLFreeHandle, SQL_HANDLE_STMT, hStmt
    .else
        invoke ShowWindow, hList, SW_HIDE
        invoke MessageBox, hDlg, addr AllocStmtFail, addr AppName, MB_OK + MB_ICONERROR
    .endif
    ret
RunQuery endp
; 
QueryProc proc hDlg :DWORD, uMsg :DWORD, wParam :DWORD, lParam :DWORD	
    .if uMsg==WM_CLOSE
        invoke SQLFreeHandle, SQL_HANDLE_STMT, hStmt
        invoke EndDialog, hDlg, 0
    .elseif uMsg==WM_INITDIALOG
        invoke ShowWindow, hList2, SW_HIDE
        invoke ShowWindow, hList3, SW_HIDE
        invoke ShowWindow, hList, SW_SHOW
        invoke SQLAllocHandle, SQL_HANDLE_STMT, hConn, addr hStmt
        .if ax==SQL_SUCCESS || ax==SQL_SUCCESS_WITH_INFO
            invoke lstrcpy, addr Conn, addr SQLStatement
            invoke lstrcat, addr Conn, addr WhereStatement
            invoke SQLBindParameter, hStmt, 1, SQL_PARAM_INPUT, SQL_C_CHAR, SQL_CHAR, 25, 0, addr SearchName, 25, addr StrLenCS
            invoke SQLPrepare, hStmt, addr Conn, sizeof Conn
        .else
            invoke ShowWindow, hList, SW_HIDE
            invoke MessageBox, hDlg, addr AllocStmtFail, addr AppName, MB_OK + MB_ICONERROR
            invoke EndDialog, hDlg, 0
        .endif
    .elseif uMsg==WM_COMMAND
        mov eax, wParam
        shr eax, 16
        .if ax==BN_CLICKED
            mov eax, wParam
            .if ax==IDC_OK
                invoke GetDlgItemText, hDlg, IDC_NAME, addr SearchName, 25
                .if ax==0
                    invoke MessageBox, hDlg, addr NoData, addr AppName, MB_OK + MB_ICONERROR
                    invoke GetDlgItem, hDlg, IDC_NAME
                    invoke SetFocus, eax
                .else
                    invoke lstrlen, addr SearchName
                    mov StrLenCS, eax
                    invoke SendMessage, hList, LVM_DELETEALLITEMS, 0, 0
                    invoke SQLExecute, hStmt
                    invoke FillData
                    invoke SQLCloseCursor, hStmt
                .endif
            .else
                invoke SQLFreeHandle, SQL_HANDLE_STMT, hStmt
                invoke EndDialog, hDlg, 0
            .endif
        .endif
    .else
        mov eax, FALSE
        ret
    .endif
    mov eax, TRUE
    ret
QueryProc endp
; 
