; 
InsertColumn2 proc
    LOCAL lvc :LV_COLUMN

; To determine the actual lengths of the TABLE_CAT, TABLE_SCHEM, and TABLE_NAME columns, an application can
; call SQLGetInfo with the SQL_MAX_CATALOG_NAME_LEN, SQL_MAX_SCHEMA_NAME_LEN, and SQL_MAX_TABLE_NAME_LEN information types.
; Note that pixels (column width) should equal the W char width times Qty returned by SQLGetInfo.
; Could make this automatic with a definitions file or profile.

             mov lvc.lx, 256                                       ; column width
             mov lvc.imask, LVCF_TEXT + LVCF_WIDTH                 ; LVCF_TEXT requires pszText, LVCF_WIDTH requires lx
             mov lvc.iSubItem, 0                                   ; zero-based index
             mov lvc.pszText, offset RetTableCol1                  ; required because we used LVCF_TEXT above
             mov lvc.cchTextMax, SizeOf RetTableCol1               ; pszText buffer size
	invoke SendMessage, hList2, LVM_INSERTCOLUMN, 1, addr lvc    ; adds column to viewlist - Catalog Name
;            mov lvc.imask, LVCF_TEXT + LVCF_WIDTH + LVCF_FMT      ; add formating capabillities to cols
;            mov lvc.fmt, LVCFMT_RIGHT                             ; the rest of the cols are assigned right justify
             mov lvc.lx, 128                                       ; new default column width
             mov lvc.iSubItem, 1                                   ; zero-based index
             mov lvc.pszText, offset RetTableCol2                  ; required because we used LVCF_TEXT above
             mov lvc.cchTextMax,  SizeOf RetTableCol2              ; pszText buffer size
	invoke SendMessage, hList2, LVM_INSERTCOLUMN, 2, addr lvc    ; adds column to viewlist - Schema Data
             mov lvc.iSubItem, 2                                   ; zero-based index
             mov lvc.pszText, offset RetTableCol3                  ; required because we used LVCF_TEXT above
             mov lvc.cchTextMax,  SizeOf RetTableCol3              ; pszText buffer size
	invoke SendMessage, hList2, LVM_INSERTCOLUMN, 3, addr lvc    ; adds column to viewlist - Table Name Data
             mov lvc.iSubItem, 3                                   ; zero-based index
             mov lvc.pszText, offset RetTableCol4                  ; required because we used LVCF_TEXT above
             mov lvc.cchTextMax,  SizeOf RetTableCol4              ; pszText buffer size
	invoke SendMessage, hList2, LVM_INSERTCOLUMN, 4, addr lvc    ; adds column to viewlist - Table Type Data
             mov lvc.iSubItem, 4                                   ; zero-based index
             mov lvc.pszText, offset RetTableCol5                  ; required because we used LVCF_TEXT above
             mov lvc.cchTextMax,  SizeOf RetTableCol5              ; pszText buffer size
	invoke SendMessage, hList2, LVM_INSERTCOLUMN, 5, addr lvc    ; adds column to viewlist - Table Description Data
    ret
InsertColumn2 endp
; 
FillData2 proc
    LOCAL lvi :LV_ITEM
    LOCAL row :DWORD
    LOCAL pNumCols :WORD

    invoke SQLBindCol, hStmt2, 1, SQL_C_CHAR, addr TField01, sizeof TField01, addr TField01L  ; Catalog Data
    invoke SQLBindCol, hStmt2, 2, SQL_C_CHAR, addr TField02, sizeof TField02, addr TField02L  ; Schema Data
    invoke SQLBindCol, hStmt2, 3, SQL_C_CHAR, addr TField03, sizeof TField03, addr TField03L  ; Table Name Data
    invoke SQLBindCol, hStmt2, 4, SQL_C_CHAR, addr TField04, sizeof TField04, addr TField04L  ; Table Type Data
    invoke SQLBindCol, hStmt2, 5, SQL_C_CHAR, addr TField05, sizeof TField05, addr TField05L  ; Table Description
    invoke SendMessage, hList2, WM_SETREDRAW, 0, 0                                            ; stop the updating of the screen area while loading hList
    mov row, 0
    .while TRUE
           mov byte ptr ds:[TField01], 0 ; We initalize the buffers to zero, incase there is no data selected
           mov byte ptr ds:[TField02], 0 ;    and we still want our procedure to finish without erroring out
           mov byte ptr ds:[TField03], 0
           mov byte ptr ds:[TField04], 0
           mov byte ptr ds:[TField05], 0
           invoke SQLFetch, hStmt2
           .if ax == SQL_SUCCESS
                mov lvi.imask, LVIF_TEXT + LVIF_PARAM
                push row
                pop lvi.iItem
                mov lvi.iSubItem, 0
                mov lvi.pszText, offset TField01
                push row
                pop lvi.lParam
                invoke SendMessage, hList2, LVM_INSERTITEM, 0, addr lvi   ; Catalog Data
                    mov lvi.imask, LVIF_TEXT
                    inc lvi.iSubItem
                    mov lvi.pszText, offset TField02
                invoke SendMessage, hList2, LVM_SETITEM, 0, addr lvi      ; Schema Data
                    inc lvi.iSubItem
                    mov lvi.pszText, offset TField03
                invoke SendMessage, hList2, LVM_SETITEM, 0, addr lvi      ; Table Name Data
                    inc lvi.iSubItem
                    mov lvi.pszText, offset TField04
                invoke SendMessage, hList2, LVM_SETITEM, 0, addr lvi      ; Table Type Data
                    inc lvi.iSubItem
                    mov lvi.pszText, offset TField05
                invoke SendMessage, hList2, LVM_SETITEM, 0, addr lvi      ; Table Description
                inc row
            .else
                .if row == 0
                    mov lvi.imask, LVIF_TEXT + LVIF_PARAM
                    push row
                    pop lvi.iItem
                    mov lvi.iSubItem, 0
                    mov lvi.pszText, offset Zrecords
                    push row
                    pop lvi.lParam
                    invoke SendMessage, hList2, LVM_INSERTITEM, 0, addr lvi
                .endif
                .break   ; when no more records left, we exit the infinite loop
            .endif
    .endw
    invoke SendMessage, hList2, WM_SETREDRAW, 1, 0       ; start the updating of the screen area for hList
    invoke ShowWindow, hList2, SW_SHOW
    ret
FillData2 endp
; 
RunTable proc hDlg :DWORD
    invoke ShowWindow, hList, SW_HIDE
    invoke ShowWindow, hList2, SW_HIDE
    invoke ShowWindow, hList3, SW_HIDE
    invoke SendMessage, hList2, LVM_DELETEALLITEMS, 0, 0
    invoke SQLAllocHandle, SQL_HANDLE_STMT, hConn, addr hStmt2
    .if ax==SQL_SUCCESS || ax==SQL_SUCCESS_WITH_INFO
        ; --------------------------------------------------------- We initalize the buffers to zero, incase there is no data selected
        ;                                                           and we still want to process to finish without erroring out
        mov byte ptr ds:[TField01], 0
        mov byte ptr ds:[TField02], 0
        mov byte ptr ds:[TField03], 0
        mov byte ptr ds:[TField04], 0
        ; --------------------------------------------------------- Ok now apply search patterns to Table strings
        invoke lstrcpy, addr TField04, addr TStr04                     ; TStr04 or TStr06
        ; --------------------------------------------------------- Ok now determine string lengths - run time method
        invoke szLen, ADDR TField01
        mov TField01L, eax
        invoke szLen, ADDR TField02
        mov TField02L, eax
        invoke szLen, ADDR TField03
        mov TField03L, eax
        invoke szLen, ADDR TField04
        mov TField04L, eax
        ; --------------------------------------------------------- After applying seaarch pattern - execute function

        invoke SQLTables, hStmt2, NULL, 0, NULL, 0, NULL, 0, NULL, 0 ; Gets everything in the Tables Collection

; if you want to filter for only tables, comment the above invoke SQLTables statement and uncomment the below statement

;        invoke SQLTables, hStmt2, NULL, 0, NULL, 0, NULL, 0, ADDR TField04, TField04L

; Table Types
;   - MSysAccessObjects   SYSTEM TABLE
;   - MSysAccessXML          "
;   - MSysACEs               "
;   - MSysObjects            "
;   - MSysQueries            "
;   - MSysRelationships      "
;   - Tables              TABLE
;   - Links               SYNONYM

        .if ax==SQL_SUCCESS || ax==SQL_SUCCESS_WITH_INFO
            invoke FillData2
        .elseif ax == SQL_ERROR
            invoke ShowWindow, hList2, SW_HIDE
            invoke MessageBox, hDlg, addr sqlerr1, addr AppName, MB_OK     ; SQL Error
        .elseif ax == SQL_INVALID_HANDLE
            invoke ShowWindow, hList2, SW_HIDE
            invoke MessageBox, hDlg, addr sqlerr2, addr AppName, MB_OK     ; Invalid Handle
        .elseif ax == SQL_NEED_DATA
            invoke ShowWindow, hList2, SW_HIDE
            invoke MessageBox, hDlg, addr sqlerr3, addr AppName, MB_OK     ; SQL incomplete
        .elseif ax == SQL_NO_DATA
            invoke ShowWindow, hList2, SW_HIDE
            invoke MessageBox, hDlg, addr sqlerr4, addr AppName, MB_OK     ; SQL returned no data
        .elseif ax == SQL_STILL_EXECUTING
            invoke MessageBox, hDlg, addr sqlerr5, addr AppName, MB_OK     ; Still executing SQL stmt
        .else
            invoke ShowWindow, hList2, SW_HIDE
            invoke MessageBox, hDlg, addr ExecuteFail, addr AppName, MB_OK + MB_ICONERROR
        .endif
        invoke SQLCloseCursor, hStmt2
        invoke SQLFreeHandle, SQL_HANDLE_STMT, hStmt2
    .else
        invoke ShowWindow, hList2, SW_HIDE
        invoke MessageBox, hDlg, addr AllocStmtFail, addr AppName, MB_OK + MB_ICONERROR
    .endif
    ret
RunTable endp
; 
